#!/usr/bin/perl

# Custom Cockfighter editing script
# By Nicholas "Captain Spam" Killewald, 2000
# This is redistributable under the GPL

# Revision history

# Version 1.01 (10/7/2000): 
#	Added the option to CREATE a new cocks.inc
#		(Either parameter -c or if cocks.inc doesn't exist)
#	Added a check in the writeback to make sure it's legal
# Version 1.00 (10/6/2000): 
#	Original release

# *** THIS SCRIPT IS NOT IDIOTPROOF!  DON'T SCREW UP YOUR INPUTS! ***

sub parse_out {

	# This puppy parses out the cocks.inc file into the arrays
	# and such.  Requires cocks.inc to exist AND have legal
	# values in it.

	# To save meself the trouble, here's what's defined after
	# this mess runs...

	# $number, the number (Not zero offset)
	# @names, an array storing each name (in order)
	# %names, a hash allowing me to pull array values from names
	# @special, an array storing the specials
	# @abil[life|off|def|spec], the life/off/def/spec power array,
	# $compiler, the special message
	# $version, the version or edition

	my $temp=0;

	open(FILE, "cocks.inc") || die "Can't pop open the .inc file... $!";

	# Snag number
	<FILE>;
	$number=<FILE>;
	chomp($number);
	substr($number, 0, 5)="";
	if($number>255){
		print "*** ERROR!  The cocks.inc file has an invalid Number field! ***\n";
		print "(Too large, max is 255)\n";
		exit;
	}
	if($number<0){
		print "*** ERROR!  The cocks.inc file has an invalid Number field! ***\n";
		print "(Too small, min is 0)\n";
		exit;
	}
	<FILE>;
	# Done there

	# Snag characters
	<FILE>;
	while(<FILE>){
		if($_ eq "\n"){
			$temp--;
			last;
		}
		chomp;
		substr($_, 0, 6)="";
		substr($_, -3, 3)="";
		$names[$temp]=$_;
		if(defined($names{$_})){
			print "***   ERROR!  The cocks.inc file has multiple definitions   ***\n";
			print "*** for the $_ fighter, and can't be used with this script! ***\n";
			exit;
		}
		$names{$_}=$temp;
		$temp++;
	}
	# Done there

	$temp=0;

	# Snag specials
	<FILE>;
	while(<FILE>){
		if($_ eq "\n"){
			$temp--;
			last;
		}
		chomp;
		substr($_, 0, 6)="";
		substr($_, -3, 3)="";
		$special[$temp]=$_;
		$temp++;
	}
	# Done there

	$temp=0;
	
	# Snag abilities, seperated by spaces in-file
	<FILE>;
	while(<FILE>){
		if($_ eq "\n"){
			$temp--;
			last;
		}
		chomp;
		substr($_, 0, 5)="";
		s/,/ /g;
		($abillife[$temp],$abiloff[$temp],$abildef[$temp],$abilspec[$temp])=split(/ /, $_);
		$temp++;		
	}
	# Done there

	# Bypass the FStat (A for loop will kill these off)
	<FILE>;		# newline
	<FILE>;		# FStat:
	for($i=0; $i<=$number; $i++){
		<FILE>;
	}

	# Snag compiler
	<FILE>;
	chomp($compiler=<FILE>);
	substr($compiler, 0, 6)="";
	substr($compiler, -3, 3)="";
	<FILE>;
	# Done there

	# Snag version
	<FILE>;
	chomp($version=<FILE>);
	substr($version, 0, 6)="";
	substr($version, -3, 3)="";
	# Done there
	
	close(FILE);
}

sub write_back {

	# Back to the file it goes...

	# Crude copy

	if($keep eq "yep"){
		open(IN, "cocks.inc");
		open(OUT, ">cocks.inc.bak");
		while(<IN>){
			print OUT;
		}
		close(IN);
		close(OUT);
	}

	open(FILE, ">cocks.inc") || die "PROBLEM!  Can't write back to cocks.inc... $!\nYour changes HAVE NOT BEEN SAVED!\n";

	print FILE "Number:\n";
	print FILE "\t.db $number\n";
	print FILE "\nChar:\n";

	for($i=0; $i<$number; $i++){
		print FILE "\t.db \"$names[$i]\",0\n";
	}

	print FILE "\nSpec:\n";

	for($i=0; $i<$number; $i++){
		print FILE "\t.db \"$special[$i]\",0\n";
	}

	print FILE "\nStat:\n";
	for($temp=0; $temp<=($number-1); $temp++){
		print FILE "\t.db $abillife[$temp],$abiloff[$temp],$abildef[$temp],$abilspec[$temp]\n";

	}

	print FILE "\nFStat:\n";

	for($temp=0; $temp<=($number-1); $temp++){
		print FILE "\t.db 0,0\n";
	}

	print FILE "\n\ncompiler:\n";
	print FILE "\t.db \"$compiler\",0\n";
	print FILE "\nVersion:\n";
	print FILE "\t.db \"$version\",0\n";
	print FILE "\n\n.end";
	close(FILE);
}

sub spit_fighters {

	if($number==0){
		print "*** No can do... no fighters in database. ***\n";
		return;
	}

	print "Number of lines at a time? ";
	chomp($repeat=<STDIN>);

	my $temp=0;

	while(1){
		print "Name                Special         Lif Off Def Spc\n";
		for($i=1; $i<=$repeat; $i++){
			if($temp==$number){
				last;
			}
			printf "%-18s  %-14s  %3s %3s %3s %3s\n",$names[$temp],$special[$temp],$abillife[$temp],$abiloff[$temp],$abildef[$temp],$abilspec[$temp];
			$temp++;
		}
		print "Press enter...";
		<STDIN>;
		last if($temp==$number);
	}
}

sub jam_in {
	if($number>=255){
		print "*** No can do, max fighter number reached. ***\n";
		return;
	}

	print "NOTE: All limits will be truncated.\n\n";

	print "New character name? (18 char max) ";
	chomp($newname=<STDIN>);
	$newname=substr($newname, 0, 18);
	if(defined($names{$newname}) && $names{$newname} ne "DEAD"){
		print "*** That name already exists in the database. ***\n";
		return;
	}

	print $newname."'s Special Move? (14 char max) ";
	chomp($newspec=<STDIN>);
	$newspec=substr($newspec, 0, 14);

	print "All abilities are 0-255.  Over/underflows will be set to\n";
	print "maximum/minimum values.\n\n";

	print $newname."'s health? (20 is good) ";
	chomp($newlife=<STDIN>);
	$newlife=255 if($newlife>255);
	$newlife=0 if($newlife<0);

	print $newname."'s offense? (7 is good) ";
	chomp($newoff=<STDIN>);
	$newoff=255 if($newoff>255);
	$newoff=0 if($newoff<0);

	print $newname."'s defense? (7 is good) ";
	chomp($newdef=<STDIN>);
	$newdef=255 if($newdef>255);
	$newdef=0 if($newdef<0);

	print "The power of ".$newname."'s ".$newspec." move? (15 is good) ";
	chomp($newspeci=<STDIN>);
	$newspeci=255 if($newspeci>255);
	$newspeci=0 if($newspeci<0);

	print "\nSo, let me get this straight...\n";
	print "Fighter number ".($number+1).":\n";
	print "Name: $newname\n";
	print "Special: $newspec\n";
	print "Lif: $newlife Off: $newoff Def: $newdef Spc: $newspeci\n";
	print "\nIs this correct? (y or Y) ";
	chomp($dec=<STDIN>);
	if($dec eq "y" or $dec eq "Y"){
		$names[$number]=$newname;
		$special[$number]=$newspec;
		$abillife[$number]=$newlife;
		$abiloff[$number]=$newoff;
		$abildef[$number]=$newdef;
		$abilspec[$number]=$newspeci;
		$names{$newname}=$number;
		$number++;
		print "$newname added to database.\n";
	} else {
		print "Changes NOT written.\n";
	}
}

sub kill_off {
	if($number<=0){
		print "*** No can do... no fighters in database. ***\n";
		return;
	}

	if($number==1){
		print "*** WARNING: After this, the database will be empty. ***\n";
	}

	if($number==2){
		print "*** WARNING: After this, there will only be one fighter. ***\n";
		print "*** The program will fail if there is only one fighter.  ***\n";
	}

	print "Name of fighter to remove? (Match capitalization) ";
	chomp($input=<STDIN>);

	if(!defined($names{$input}) or $names{$input} eq "DEAD"){
		print "*** Fighter doesn't exist in the database. ***\n";
		print "***   Make sure you match capitalization.  ***\n";
		return;
	}

	$cur=$names{$input};

	print "Okay...\n";
	print "Fighter number ".($cur+1).":\n";
	print "Name: $names[$cur]\n";
	print "Special: $special[$cur]\n";
	print "Lif: $abillife[$cur] Off: $abiloff[$cur] Def: $abildef[$cur] Spc: $abilspec[$cur]\n";
	print "\n*** THIS FIGHTER WILL BE REMOVED! ***\n";
	print "Are you sure? (y or Y) ";
	chomp($dec=<STDIN>);
	
	if($dec eq "y" or $dec eq "Y"){
		$names{$input}="DEAD";
		$number--;
		while($cur<$number){
			$cur++;
			$names[$cur-1]=$names[$cur];
			$special[$cur-1]=$special[$cur];
			$abillife[$cur-1]=$abillife[$cur];
			$abiloff[$cur-1]=$abiloff[$cur];
			$abildef[$cur-1]=$abildef[$cur];
			$abilspec[$cur-1]=$abilspec[$cur];
		}
		for($i=0; $i<$number; $i++){
			$names{$names[$i]}=$i;
		}
	print "Done.\n";
	return;

	} else {
		print "Fighter NOT deleted.\n";
		return;
	}
}	

sub change_up {
	if($number<=0){
		print "*** No can do... no fighters in database. ***\n";
		return;
	}

	print "What fighter do you want to modify? (Match capitalization) ";
	chomp($input=<STDIN>);
	if(!defined($names{$input}) || $names{$input} eq "DEAD"){
		print "*** Fighter does not exist in the database. ***\n";
		print "*** Make sure you got capitalization right. ***\n";
		return;
	}

	$cur=$names{$input};

	print "Righto... As of right now...\n";
	print "Fighter number ".($cur+1).":\n";
	print "Name: $names[$cur]\n";
	print "Special: $special[$cur]\n";
	print "Lif: $abillife[$cur] Off: $abiloff[$cur] Def: $abildef[$cur] Spc: $abilspec[$cur]\n";
	print "\n";

	print "New name? (18 char max, currently $names[$cur]) ";
	chomp($newname=<STDIN>);
	$newname=substr($newname, 0, 18);
	if(defined($names{$newname}) and $newname ne $input){
		print "*** That name is already in the database. ***\n";
		return;
	}

        print $newname."'s new Special Move? (14 char max, currently $special[$cur]) ";
        chomp($newspec=<STDIN>);
        $newspec=substr($newspec, 0, 14);
	
        print $newname."'s new health? (20 is good, currently $abillife[$cur]) ";
        chomp($newlife=<STDIN>);
        $newlife=255 if($newlife>255);
        $newlife=0 if($newlife<0);
        
        print $newname."'s new offense? (7 is good, currently $abiloff[$cur]) ";
        chomp($newoff=<STDIN>);
        $newoff=255 if($newoff>255);
        $newoff=0 if($newoff<0);

        print $newname."'s new defense? (7 is good, currently $abildef[$cur]) ";
        chomp($newdef=<STDIN>); 
        $newdef=255 if($newdef>255);  
        $newdef=0 if($newdef<0);  
        
        print "The power of ".$newname."'s new ".$newspec." move? (15 is good, currently $abilspec[$cur]) ";
        chomp($newspeci=<STDIN>);
        $newspeci=255 if($newspeci>255);
        $newspeci=0 if($newspeci<0);
	
	print "So, you're saying the NEW character is...\n";
        print "Fighter number ".($cur+1).":\n";
        print "Name: $newname\n";
        print "Special: $newspec\n";
        print "Lif: $newlife Off: $newoff Def: $newdef Spc: $newspeci\n";
        print "\nIs this correct? (y or Y) ";
        chomp($dec=<STDIN>);

        if($dec eq "y" or $dec eq "Y"){
                $names[$cur]=$newname;
                $special[$cur]=$newspec;
                $abillife[$cur]=$newlife;
                $abiloff[$cur]=$newoff;
                $abildef[$cur]=$newdef;
                $abilspec[$cur]=$newspeci;
		$names{$input}="DEAD";
                $names{$newname}=$cur;
                print "Modifications made.\n";
        } else {
                print "Changes NOT written.\n";
        }
}

$new="nope";
$keep="yep";

if((defined($ARGV[0]) and $ARGV[0] eq "-c") or !(-e "cocks.inc")){
	if($ARGV[0] eq "-c" and !(-e "cocks.inc")){
		print "-c flag used and cocks.inc doesn't exist, making new file...\n";
		$keep="nope";
	} elsif($ARGV[0] eq "-c" and -e "cocks.inc"){
		print "-c flag used and cocks.inc exists, making new file, keeping the old one...\n";
	} else {
		print "cocks.inc doesn't exist, assuming new...\n";
		$keep="nope";
	}
	$new="yep";
	$number=0;
	$compiler="Enter custom message";
	$version="Enter version message";
} else {
	print "Parsing cocks.inc...\n";
	parse_out();
}

while(1){
	
	print <<END;
Cockfighter Customizer
----------------------

1. Display fighters (currently $number in database)
2. Add fighter
3. Remove fighter
4. Edit fighter
5. Edit custom message (currently $compiler)
6. Edit version or edition (currently $version)
7. Exit, saving changes to cocks.inc
8. Exit, ditching changes
END
	
	print "\nYour selection: ";
	
	chomp($choice=<STDIN>);

	if($choice!=1 && $choice!=2 && $choice!=3 && $choice!=4
	&& $choice!=5 && $choice!=6 && $choice!=7 && $choice!=8){
		next;
	}

	if($choice==1){
		spit_fighters();
		next;
	}

	if($choice==2){
		jam_in();
		next;
	}

	if($choice==3){
		kill_off();
		next;
	}

	if($choice==4){
		change_up();
		next;
	}

	if($choice==5){
		print "Currently, the custom message is $compiler.\n";
		print "What's the new custom message?\n";
		chomp($compiler=<STDIN>);
		next;
	}

	if($choice==6){
		print "Currently, the version/edition is $version.\n";
		print "What's the new edition?\n";
		chomp($version=<STDIN>);
		next;
	}

	if($choice==7){
		if($number<2){
			print "*** Can't write back, need at least two fighers ***\n";
			next;
		}

		print "Saving cocks.inc back to file...\n";
		print "(A backup is stored as cocks.inc.bak)\n" unless($keep eq "nope");
		write_back();
		print "Done.\n";
		exit;
	}

	if($choice==8){
		print "cocks.inc HAS NOT been saved.\n";
		exit;
	}
}
